#!/usr/bin/perl -w
#Translated from BASIC by basic2pl

##############################################################################
# Main program
package Moonup;
require Exporter;

@ISA = qw(Exporter) ;
@EXPORT_OK = qw(&getmoon @moontime @myhash); 
   ; #         CONSTANTS
   ;
; # use strict;

my      $p1 = 3.14159265;
my      $p2 = 2*$p1;
my      $dr = $p1/180;
my      $k1 = 15*$dr*1.0027379;
my      $moon_s_str = "Moonset @ ";
my      $moon_r_str = "Moonrise @ ";
my      $moon_m1_str = "NO Moonrise";
my      $moon_m2_str = "NO Moonset";
my      $moon_m3_str = "Moon down all day";
my      $moon_m4_str = "Moon up all day";
my $d;
my $d5;
my $a5;
my $t3;
my $e;
my $s;
my $t0;
my $v2;
my $d2;
my $a2;
my $limit_for_c0;
my $w8;
my $d0;
my $c0;
my $dd;
my $m8;
my $c;
my $b5;
my $z1;
my $step_for_c0;
my $z0;
my @a;
my @d;
my $z;
my $a0;
my $da;
my $v0;
my $y;
my $m;
my $t;
my $tt;
my $l5;
my $h;
my $i;
my $f0;
my $f1;
my $f2;
my $a7;
my @m;
my $step_for_i;
my $limit_for_i;
my $p;


; # print "inside moonpm";

; # &getmoon($b5, $l5, $h, $y, $m, $d);
; # @moontime;


sub getmoon
{
($b5) = shift;
($l5) = shift;
($h) = shift;
($y) = shift;
($m) = shift;
($d) = shift;
$l5 = $l5/360;
$z0 = $h/24;
my @moonstr;
my @moonmes;
my $idex;


my ($j, $f) = j_date($y, $m, $d);

        $t = ($j-2451545)+$f;

my ($s, $t0) = &time_z($t, $dr, $l5, $z0);

        $t = $t+$z0;

L45:    ; # 
L50:    ; #       POSITION LOOP
L55:    $i = 1;
        $step_for_i = 1;
        $limit_for_i = 3;
        do {

my  ($a5, $d5, $r5) = &moon_pos($p2, $t);

        $m[$i][1] = $a5;
        $m[$i][2] = $d5;
        $m[$i][3] = $r5;
        $t = $t+0.5;
        $i += $step_for_i;
        } until ($step_for_i > 0 ? $i > $limit_for_i : $i < $limit_for_i);
	    if ($m[2][1] > $m[1][1]) {
            goto L85;
        }
        $m[2][1] = $m[2][1]+$p2;
L85:	   if ($m[3][1] > $m[2][1]) {
           goto L95;
        }
    	$m[3][1] = $m[3][1]+$p2;
L95:    $z1 = $dr*(90.567-41.685/$m[2][3]);
   	$s = sin($b5*$dr);
        $c = cos($b5*$dr);
   	$z = cos($z1);
        $m8 = 0;
        $w8 = 0;
        print("", "\n");
   	$a0 = $m[1][1];
        $d0 = $m[1][2];
   	$c0 = 0;
        $step_for_c0 = 1;
        $limit_for_c0 = 23;
        do {
        $p = ($c0+1)/24;
        $f0 = $m[1][1];
        $f1 = $m[2][1];
        $f2 = $m[3][1];

my ($f,) = &three_point($p, $f0, $f1, $f2);

            $a2 = $f;
   	    $f0 = $m[1][2];
            $f1 = $m[2][2];
            $f2 = $m[3][2];

($f,) = &three_point($p, $f0, $f1, $f2);

            $d2 = $f;
($c0, $v2, $d2, $a2, $m8, $w8, $idex, @moonstr) = &event_det($t0, $c0, $k1, $a2, $d2, $s, $a0, $d0, $idex, $m8, $w8);
            $a0 = $a2;
            $d0 = $d2;
            $v0 = $v2;
L150:       $c0 += $step_for_c0;
        } until ($step_for_c0 > 0 ? $c0 > $limit_for_c0 : $c0 < $limit_for_c0);

@moonmes = &spec_mes($m8, $w8, $v2);
do
{

$moonstr[$idex] ="";
$idex = $idex + 1;

} until ($idex > 6);

@moontime = (@moonstr, @moonmes);
my @moonstr;
my @moonmes;
; # print $v2;
; # print "\n";
; # print $#moontime;
return @moontime;

}
return 1;


sub three_point
{
my $a;
my $f1;
my $f0;
my $b;
my $f2;
my $f;
my $p;

($p) = shift;
($f0) = shift;
($f1) = shift;
($f2) = shift;


   ; #     3-POINT INTERPOLATION
	$a = $f1-$f0;
	$b = $f2-$f1-$a;
	$f = $f0+$p*(2*$a+$b*(2*$p-1));

return ($f);
}

sub time_z
{
my $t;
my $dr;
my $s;
my $l5;
my $z0;
my $t0;

($t) = shift;
($dr) = shift;
($l5) = shift;
($z0) = shift;

	; #      LST at 0h zone time
	$t0 = $t/36525;
	$s = 24110.5+8640184.813*$t0;
	$s = $s+86636.6*$z0+86400*$l5;
	$s = $s/86400;
	$s = $s-int($s);
	$t0 = $s*360*$dr;

return($s,$t0);
}

sub event_det
{

; # recieves   $t0, $s ,$c0,$k1,$d2, $a0, $d0,$a2
; # returns $c0,$v2,$d2,$a2,$suntime
my $t;
my $l0;
my $l2;
my $h0;
my $h1;
my $h2;
my $v1;
my $vo;
my $a;
my $d;
my $b;
my $d1;
my $d3;
my $h7;
my $n7;
my $d7;
my $az;
my $azimuth;
my $m3;
my $h3;
my $moonstr;
my $idex;
my $m8;
my $w8;


($t0) = shift;
($c0) = shift;
($k1) = shift;
($a2) = shift;
($d2) = shift;
($s) = shift;
($a0) = shift;
($d0) = shift;
($idex) = shift;
($m8) = shift;
($w8) = shift;

; # print $idex;

L280:   ; # 
L285:   ; #   TEST AN HOUR FOR AN EVENT
L290:   $l0 = $t0+$c0*$k1;
        $l2 = $l0+$k1;
	   if ($a2 < $a0) {
           $a2 = $a2+2*$p1;
	   }
	$h0 = $l0-$a0;
        $h2 = $l2-$a2;
        $h1 = ($h2+$h0)/2;
        ; #    HOUR ANGLE
        $d1 = ($d2+$d0)/2;
        ; #    DEC
        if ($c0 > 0) {
            goto L325;
        }
        $v0 = $s*sin($d0)+$c*cos($d0)*cos($h0)-$z;
L325:   $v2 = $s*sin($d2)+$c*cos($d2)*cos($h2)-$z;
        if (sgn($v0) == sgn($v2)) {
            goto L440;
        }
        $v1 = $s*sin($d1)+$c*cos($d1)*cos($h1)-$z;
L340:   $a = 2*$v2-4*$v1+2*$v0;
        $b = 4*$v1-3*$v0-$v2;
L345:   $d = $b*$b-4*$a*$v0;
        if ($d < 0) {
            goto L440;
        }
        $d = sqrt($d);
        if ($v0 < 0 && $v2 > 0) {
; #             print($moon_r_str);

$moonstr[$idex] = sprintf($moon_r_str);
$idex = $idex + 1;

        }
        if ($v0 < 0 && $v2 > 0) {
            $m8 = 1;
        }
        if ($v0 > 0 && $v2 < 0) {
; #            print($moon_s_str);
; #            print($moon_s_str);

$moonstr[$idex] = sprintf($moon_s_str);
$idex = $idex + 1;


        }
        if ($v0 > 0 && $v2 < 0) {
           $w8 = 1;
        }
        $e = (-$b+$d)/(2*$a);
        if ($e > 1 || $e < 0) {
            $e = (-$b-$d)/(2*$a);
        }
        $t3 = $c0+$e+1/120;
        ; #   ROUND OFF
        $h3 = int($t3);
        $m3 = int(($t3-$h3)*60);
; # next if statement converts miniuts to a text string in order to preserve leading zero
        if ($m3 < 10)
	{
		 $m3 = sprintf("%02d",$m3);
	}
; #        print($h3,':',$m3,' ');
; #         print($h3,':',$m3,' ');

$moonstr[$idex] = sprintf($h3.":".$m3." ");
$idex = $idex + 1;


        $h7 = $h0+$e*($h2-$h0);
        $n7 = -cos($d1)*sin($h7);
        $d7 = $c*sin($d1)-$s*cos($d1)*cos($h7);
        $a7 = atan2($n7,$d7)/$dr;
        if ($d7 < 0) {
            $a7 = $a7+180;
        }
        if ($a7 < 0) {
            $a7 = $a7+360;
        }
        if ($a7 > 360) {
            $a7 = $a7-360;
        }
       $azimuth=sprintf("%.3f", $a7,' ', "\n");


$moonstr[$idex] = sprintf(", Azimuth ".$azimuth."\n");
$idex = $idex + 1;


; ##################################################

; # return ($c0, $v2, $d2, $a2, $m8, $w8, @moontime);
; # print "inside line 440";
; # left above not sure how exits rountine
; ##################################################
L440: 
; # $moontime = "";
; # print @moonstr;
; # print $idex;
return ($c0, $v2, $d2, $a2, $m8, $w8, $idex, @moonstr);
}

sub spec_mes
{
my $m8;
my $w8;
my $v2;
my @moonmes;
($m8) = shift;
($w8) = shift;
($v2) = shift;
; # print $m8;
; # print "\n";
; # print $w8;
; # print "\n";
; # print $v2;
; # print "\n";


; # print "eneterd spec mess";

; # print @moontime;

L445:   ; # 
L450:   ; #    SPECIAL MESSAGE ROUTINE
L455:   if ($m8 == 0 && $w8 == 0) {
            goto L475;
        }
L460:   if ($m8 == 0) {
            ; # print($moon_m1_str, "\n");
         $moonmes[1] = sprintf($moon_m1_str. "\n");
        }
L465:   if ($w8 == 0) {
            ; # print($moon_m2_str, "\n");
           $moonmes[1]  = sprintf($moon_m2_str. "\n");
        }
L470:   goto L485;
L475:   if ($v2 < 0) {
            ; # print($moon_m3_str, "\n");
       $moonmes[1] = sprintf($moon_m3_str. "\n");
        }
L480:   if ($v2 > 0) {
            ; # print($moon_m4_str, "\n");
          $moonmes[1] = sprintf($moon_m4_str. "\n");
        }
L485:

return (@moonmes);

}

sub moon_pos
{
my $l;
my $m;
my $f;
my $d;
my $n;
my $g;
my $v;
my $u;
my $w;
my $s;
my $w;
my $a5;
my $d5;
my $r5;
($p2) = shift;
($t) = shift;

L490:   ; # 
L495:   ; #    FUNDAMENTAL ARGUMENTS
L500:   $l = 0.606434+0.03660110129*$t;
L505:   $m = 0.374897+0.03629164709*$t;
L510:   $f = 0.259091+0.0367481952*$t;
L515:   $d = 0.827362+0.03386319198*$t;
L520:   $n = 0.347343-0.00014709391*$t;
L525:   $g = 0.993126+0.0027377785*$t;
L530:   $l = $l-int($l);
        $m = $m-int($m);
L535:   $f = $f-int($f);
        $d = $d-int($d);
L540:   $n = $n-int($n);
        $g = $g-int($g);
L545:   $l = $l*$p2;
        $m = $m*$p2;
        $f = $f*$p2;
L550:   $d = $d*$p2;
        $n = $n*$p2;
        $g = $g*$p2;
L555:   $v = 0.39558*sin($f+$n);
L560:   $v = $v+0.082*sin($f);
L565:   $v = $v+0.03257*sin($m-$f-$n);
L570:   $v = $v+0.01092*sin($m+$f+$n);
L575:   $v = $v+0.00666*sin($m-$f);
L580:   $v = $v-0.00644*sin($m+$f-2*$d+$n);
L585:   $v = $v-0.00331*sin($f-2*$d+$n);
L590:   $v = $v-0.00304*sin($f-2*$d);
L595:   $v = $v-0.0024*sin($m-$f-2*$d-$n);
L600:   $v = $v+0.00226*sin($m+$f);
L605:   $v = $v-0.00108*sin($m+$f-2*$d);
L610:   $v = $v-0.00079*sin($f-$n);
L615:   $v = $v+0.00078*sin($f+2*$d+$n);
L620:   $u = 1-0.10828*cos($m);
L625:   $u = $u-0.0188*cos($m-2*$d);
L630:   $u = $u-0.01479*cos(2*$d);
L635:   $u = $u+0.00181*cos(2*$m-2*$d);
L640:   $u = $u-0.00147*cos(2*$m);
L645:   $u = $u-0.00105*cos(2*$d-$g);
L650:   $u = $u-0.00075*cos($m-2*$d+$g);
L655:   $w = 0.10478*sin($m);
L660:   $w = $w-0.04105*sin(2*$f+2*$n);
L665:   $w = $w-0.0213*sin($m-2*$d);
L670:   $w = $w-0.01779*sin(2*$f+$n);
L675:   $w = $w+0.01774*sin($n);
L680:   $w = $w+0.00987*sin(2*$d);
L685:   $w = $w-0.00338*sin($m-2*$f-2*$n);
L690:   $w = $w-0.00309*sin($g);
L695:   $w = $w-0.0019*sin(2*$f);
L700:   $w = $w-0.00144*sin($m+$n);
L705:   $w = $w-0.00144*sin($m-2*$f-$n);
L710:   $w = $w-0.00113*sin($m+2*$f+2*$n);
L715:   $w = $w-0.00094*sin($m-2*$d+$g);
L720:   $w = $w-0.00092*sin(2*$m-2*$d);
L725:   ; # 
L730:   ; #     COMPUTE RA, DEC, DIST
L735:   $s = $w/sqrt($u-$v*$v);
L740:   $a5 = $l+atan2($s/sqrt(1-$s*$s),1);
L745:   $s = $v/sqrt($u);
        $d5 = atan2($s/sqrt(1-$s*$s),1);
L750:   $r5 = 60.40974*sqrt($u);
return ($a5, $d5, $r5);
}

sub j_date
{
my $y;
my $m;
my $d;
my $g;
my $a;
my $s;
my $j3;
my $d1;
my $f;
my $j;

($y) = shift;
($m) = shift;
($d) = shift;


; # L760:   ; #      CALENDAR --> JD

 L770:   $g = 1;
         if ($y < 1582) {
             $g = 0;
         }
 L775:   $d1 = int($d);
         $f = $d-$d1-0.5;
 L780:   $j = -int(7*(int(($m+9)/12)+$y)/4);
 L785:   if ($g == 0) {
             goto L805;
         }
 L790:   $s = sgn($m-9);
         $a = abs($m-9);
 L795:   $j3 = int($y+$s*int($a/7));
 L800:   $j3 = -int((int($j3/100)+1)*3/4);
 L805:   $j = $j+int(275*$m/9)+$d1+$g*$j3;
 L810:   $j = $j+1721027+2*$g+367*$y;
 L815:   if ($f >= 0) {
             goto L825;
         }
 L820:   $f = $f+1;
         $j = $j-1;
 L825: return($j, $f);

}

sub sgn
{
return $_[0] == 0 ? 0 : $_[0] < 0 ? -1 : 1;
}
L900:   ; #   ***************************
L910:   ; #   THIS PROGRAM COMPUTES THE
L920:   ; #   TIMES OF MOONRISE AND MOON-
L930:   ; #   SET ANYWHERE IN THE WORLD.
L940:   ; #   FROM SKY & TELESCOPE, JULY,
L950:   ; #   1989, PAGE 78.
L960:   ; #   ***************************
